### R code from vignette source 'regr-description.Rnw'
### Encoding: UTF-8

###################################################
### code chunk number 1: preliminary
###################################################
## library(regr0)
library(regr0) ##, lib="/u/stahel/R/regdevelop/pkg/regr0.Rcheck")
mframe()
userOptions(project="regr0 documentation")



###################################################
### code chunk number 2: regrout
###################################################
data(d.blast)
d.blast$location <- factor(d.blast$location)
r.blast <- regr(logst(tremor) ~ location + log10(distance) + log10(charge), 
    data = d.blast)
r.blast



###################################################
### code chunk number 3: termtable
###################################################
names(r.blast$termtable)
userOptions(termcolumns=c("coef", "stcoef", "df", "signif", "p.symb"))

r.blast


###################################################
### code chunk number 4: modeltable
###################################################
names(d.blast)
r.blast2 <- 
  regr(logst(tremor) ~ ( location + log10(distance) + log10(charge) )^2,
       data=d.blast)
## modelTable(c("r.blast","r.blast2"))             


###################################################
### code chunk number 5: add1
###################################################
add1(r.blast)

r.step <- step(r.blast, k=5)
formula(r.step)


###################################################
### code chunk number 6: taplot
###################################################
r.blast <-
  regr(log10(tremor)~location+log10(distance)+log10(charge), data=d.blast)
plot(r.blast, plotselect=c(ta=3, default=0), xplot=F, mf=c(1,1) )



###################################################
### code chunk number 7: xdist
###################################################
data(d.blast)
rr <- regr(tremor~distance+charge, data=d.blast)
## an inadequate model!
xdrd <- xdistResdiff(rr)
plot(xdrd)



###################################################
### code chunk number 8: taordered
###################################################
data(d.surveyenvir)
dd <- d.surveyenvir
t.rr <- regr(disturbance~age+education+location, data=dd)
plot(t.rr, plotselect=c(ta=3, default=0), xplot=F, mf=c(1,1),
     ask=FALSE)



###################################################
### code chunk number 9: plmatrix
###################################################
plmatrix(iris[,1:4], main="Iris", pch=as.numeric(iris[,"Species"]))



###################################################
### code chunk number 10: mboxes
###################################################
plmboxes(residuals(r.blast)~location, data=d.blast)



###################################################
### code chunk number 11: mboxes2
###################################################
data(d.blast)
plmboxes(tremor~location+I(charge>5), data=d.blast)



